#ifndef _data_h_
#define _data_h_

#define TG_FONT 		"%FONT;\0"
#define TG_BLOCK		"%BLOCK;\0"
#define TG_BLOCK_FB		"%BLOCK-FB;\0"
#define TG_PARAGRAPH	"%PARAGRAPH;\0"
#define TG_INLINE		"%INLINE;\0"
#define TG_MARGINTAGS	"%MARGINTAGS;\0"
#define TG_BORDERTAGS	"%BORDERTAGS;\0"
#define TG_FONTTAGS		"%FONTTAGS;\0"
#define TG_BLOCK_NO_PG	"%BLOCK-NO-PG;\0"

typedef char *tPChar;
typedef tPChar *tPPChar;

struct Tag;
struct Property;

typedef char (*tPConvertPropertyTypeFunction) (struct Tag * pTag,
											   struct Property * pProp);
typedef char (*tPProcessTagFunction) (struct Tag * pTag);

typedef enum TriStateType
	{ Yes, MayBe, No }
tTriState;

typedef struct PropertyType
	{
		tPChar Name;
		tPChar MapTo;
		tPChar ValidInTags;
		tPConvertPropertyTypeFunction pConvertPropertyType;
	}
tPropertyType;

typedef tPropertyType *tPPropertyType;

typedef struct Property
	{
		tPPropertyType Type;
		tPChar Value;
		struct Property *Next;
	}
tProperty;

typedef tProperty *tPProperty;
typedef tPProperty *tPPProperty;

typedef struct TagType
	{
		tPChar Name;
		tPChar MapTo;
		tTriState EndTag, Cascade, CloseXMLTag, ConvertProperties, SetupIndent;
		tPChar CloseOtherTags;
		tPChar ValidSubTags;
		tPProcessTagFunction pProcessTag;
		tPProcessTagFunction pProcessTagBefore;
	}
tTagType;

typedef tTagType *tPTagType;

typedef struct Tag
	{
		tPChar FullTag;
		tPTagType Type;
		tPProperty Properties;
		struct Tag *Parent;
		tPChar TextIn;
		struct Tag *SubTags, *LastSubTag;
		tPChar TextAfter;
		struct Tag *Next;
	}
tTag;

typedef tTag *tPTag;
typedef tPTag *tPPTag;

typedef struct SpecialChar
	{
		tPChar Name;
		tPChar MapTo;
		tPChar MapToBefore;
		tPChar MapToAfter;
	}
tSpecialChar;

typedef tSpecialChar *tPSpecialChar;
typedef tPSpecialChar *tPPSpecialChar;

typedef struct TagGroup
	{
		tPChar Name;
		tPChar MapTo;
	}
tTagGroup;

typedef tTagGroup *tPTagGroup;
typedef tPTagGroup *tPPTagGroup;

typedef struct PreDefProperty
	{
		tPChar Tag;
		tPChar Property;
		tPChar Value;
	}
tPreDefProperty;

typedef tPreDefProperty *tPPreDefProperty;
typedef tPPreDefProperty *tPPPreDefProperty;



extern tPropertyType DefPropertyTypes[];

extern tTagType DefTagTypes[];

extern tTag *ROOT;

extern tPTag TagStack[50];
extern int TagStackPos;

extern tSpecialChar DefSpecialChar[];

extern tTagGroup DefTagGroups[];

extern tPreDefProperty DefPreDefProperties[];

extern tPChar LangCodes[][2];

#endif

