#include "html2fo.h"
#include "structs.h"

int TableCount = 0;
int TableDepth = 0;
char ProcessTagTableBefore(tPTag pTag)
{
	tPTag pt = pTag, ptco = NULL, ptbo = NULL, ptro, ptce = NULL;
	tPProperty pp, pp2, ppb;
	int cocount1 = 0, coco, colspan, colzaehl, colindex;
	int tablewidthpix = StdDocWidthPixel;
	double maxTableWidth;
	double colwidth = 0.0f, colwidth2 = 0.0f;
	char tmpstr[20];
	char Aenderung, flag;
	int rowspans[100] = { 0 };

	TableCount++;
	TableDepth++;
	fprintf(myout,
			"starting table processing step 1 of 2 for table %i depth %i\n",
			TableCount, TableDepth);

	maxTableWidth = GetMaxWidth(pt->Parent);
	tablewidthpix = (int) (maxTableWidth * StdDocWidthPixel / StdDocWidthcm);

	pp = SearchProperty(pt, "WIDTH");
	ppb = SearchProperty(pt, "BORDER");

	if (pp != NULL)
	{
		tablewidthpix = (int) ap2f(pp->Value, tablewidthpix, tablewidthpix);
	}


	if (pt->SubTags == NULL)
	{
		InsertAsSubTag(pt, "TR");
		fprintf(myout, "at least one row is needed for table processing\n");
	}

	if (pt->SubTags->Type == SearchTagType(pt, "XML-TABLE-COLUMN"))
	{
		fprintf(myout, " Table with Columns - parsing...");

		ptco = pt->SubTags;

		cocount1 = 1;

		while ((ptco != NULL)
			   && (ptco->Next->Type == SearchTagType(pt, "XML-TABLE-COLUMN")))
		{
			pp = SearchProperty(ptco, "XML-TABLE-COLUMN-WIDTH");

			if (pp != NULL)
			{
				colwidth = ap2f(pp->Value, -1.0f, tablewidthpix);

				if (colwidth > -1.0f)
				{
					sprintf(&tmpstr[0], NumberFormat "cm",
							colwidth * maxTableWidth / tablewidthpix);
					free(pp->Value);
					pp->Value = strdup(&tmpstr[0]);
					memblocks++;
				}
			}
			cocount1++;
			ptco = ptco->Next;
		}

		pp = SearchProperty(ptco, "XML-TABLE-COLUMN-WIDTH");

		if (pp != NULL)
		{
			colwidth = ap2f(pp->Value, -1.0f, tablewidthpix);

			if (colwidth > -1.0f)
			{
				sprintf(&tmpstr[0], NumberFormat "cm",
						colwidth * maxTableWidth / tablewidthpix);
				free(pp->Value);
				pp->Value = strdup(&tmpstr[0]);
				memblocks++;
			}
		}

		ptbo = AddTagAfterIncRest(ptco, "XML-TABLE-BODY");

		fprintf(myout, " done\n");
		fprintf(myout, " Processing cells...\n  ");

		ptco = pt->SubTags;
		ptro = ptbo->SubTags;

		while (ptro != NULL)
		{
			ptce = ptro->SubTags;

			if (ptce == NULL)
			{
				InsertAsSubTag(ptro, "TD");
				ptce = ptro->SubTags;
			}

			coco = 0;

			while (ptce != NULL)
			{
				while (rowspans[coco] > 0)
				{
					coco++;
					ptco = ptco->Next;

					if (ConvertRowSpans == true)
						AddTagBefore(ptce, "XML-EMPTY-CELL");
					fprintf(myout, "!");
				}

				pp = SearchProperty(ptce, "ROWSPAN");

				if (pp != NULL)
				{
					rowspans[coco] = a2l(pp->Value, 0);
				}

				pp = SearchProperty(ptce, "COLSPAN");



				if ((pp == NULL) || (a2l(pp->Value, 0) == 1))
				{				/* single cell */
					pp2 = SearchProperty(ptco, "XML-COLUMN-WIDTH");
					coco++;
					if (((ptco->Next == NULL)
						 ||
						 (strcmp
						  (ptco->Next->Type->Name,
						   "XML-TABLE-COLUMN") != 0)) && (ptce->Next != NULL))
					{
						cocount1++;
						ptco = AddTagAfter(ptco, "XML-TABLE-COLUMN");
						ptco->TextAfter = getIndent(ptco);
					}
					else
						ptco = ptco->Next;

					fprintf(myout, "+");
				}
				else
				{				/* col-spanned cell */
					colindex = colspan = a2l(pp->Value, 1);
					fprintf(myout, "%*s", colspan - 1, "-");
					colzaehl = 0;
					colwidth = 0.0f;

					while (colspan > 0)
					{
						pp2 = SearchProperty(ptco, "XML-COLUMN-WIDTH");
						if ((pp2 != NULL) && (pp2->Value != NULL))
							colwidth += a2f(pp2->Value, 0.0f);
						colzaehl++;
						coco++;
						if (((ptco->Next == NULL)
							 ||
							 (strcmp
							  (ptco->Next->Type->Name,
							   "XML-TABLE-COLUMN") != 0))
							&& (ptce->Next != NULL))
						{
							cocount1++;
							ptco = AddTagAfter(ptco, "XML-TABLE-COLUMN");
						}
						else
							ptco = ptco->Next;
						if (colspan > 1)
							rowspans[coco] = rowspans[coco - 1];
						colspan--;
					}
					sprintf(&tmpstr[0], NumberFormat "cm", colwidth);
					fprintf(myout, "+");
				}

				if (ptce != NULL)
				{
					ptce = ptce->Next;
				}
			}

			while (rowspans[coco] > 0)
			{
				coco++;
				ptco = ptco->Next;
				if (ConvertRowSpans == true)
					AddSubTagLast(ptro, "XML-EMPTY-CELL");
				fprintf(myout, "!");
			}

			fprintf(myout, "\n  ");

			colzaehl = cocount1;
			while (colzaehl > 0)
			{
				colzaehl--;
				if (rowspans[colzaehl] > 0)
					rowspans[colzaehl]--;
			}

			if (coco != cocount1)
			{
				fprintf(myout,
						"wrong column count (first row: %i - this row: %i!!!\n ",
						cocount1, coco);
				printTagFilePos(myout, ptro);
				while (coco < cocount1)
				{
					if (ConvertRowSpans == true)
						AddSubTagLast(ptro, "XML-EMPTY-CELL");
					coco++;
					ptco = ptco->Next;
				}
			}

			ptco = pt->SubTags;

			if (ptro != NULL)
			{
				ptro = ptro->Next;
			}
		}
		fprintf(myout, "done\n");
	}
	else
	{
		ptbo = InsertAsSubTag(pt, "XML-TABLE-BODY");

		pt->TextIn = strdup("\n");

		ptro = ptbo->SubTags;

		fprintf(myout,
				" retrieving table columns from non-col-spanned cells...\n ");

		while (ptro != NULL)
		{
			ptce = ptro->SubTags;

			if (ptce == NULL)
			{
				InsertAsSubTag(ptro, "TD");
				ptce = ptro->SubTags;
			}

			coco = 0;

			while (ptce != NULL)
			{
				while (rowspans[coco] > 0)
				{
					coco++;
					if ((ptco != NULL) && (ptco->Next != NULL))
					{
						ptco = ptco->Next;
					}
					else
						fprintf(myout,
								"internal error while table processing!!!\n ");

					if (ConvertRowSpans == true)
						AddTagBefore(ptce, "XML-EMPTY-CELL");
					fprintf(myout, "!");
				}

				pp = SearchProperty(ptce, "ROWSPAN");

				if (pp != NULL)
				{
					rowspans[coco] = a2l(pp->Value, 0);
				}

				pp = SearchProperty(ptce, "COLSPAN");

				if (ptbo->SubTags == ptro)
				{				/* first row */

					if ((pp == NULL) || (a2l(pp->Value, 0) == 1))
					{			/* single cell */
						cocount1++;
						coco = cocount1;

						if (ptco == NULL)
						{
							ptco = AddSubTagFirst(pt, "XML-TABLE-COLUMN");
						}
						else
						{
							ptco = AddTagAfter(ptco, "XML-TABLE-COLUMN");
						}

						ptco->TextAfter = strdup("\n");

						if (ptco != NULL)
						{
							pp = AddProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
							if (pp != NULL)
							{
								pp2 = SearchProperty(ptce, "WIDTH");

								if (pp2 != NULL)
								{
									if ((pp2->Value == NULL)
										|| ((strcmp(pp2->Value, "*") != 0)
											&& (strcmp(pp2->Value, "100%")
												!= 0)))
									{
										colwidth =
											ap2f(pp2->Value, -1.0f,
												 tablewidthpix);

										if (colwidth > -1.0f)
										{
											sprintf(&tmpstr[0],
													NumberFormat "cm",
													colwidth *
													maxTableWidth /
													tablewidthpix);
											pp->Value = strdup(&tmpstr[0]);
											memblocks++;
											fprintf(myout, "x");
										}
										else
											fprintf(myout, "+");
									}
									else
									{
										free(pp2->Value);
										RemoveProperty(ptce, pp2);
										fprintf(myout, "+");
									}
								}
								else
									fprintf(myout, "+");
							}
							else
							{
								fprintf(myout,
										"\n Error while processing table!!!\n");
							}
						}
						else
						{
							fprintf(myout,
									"\n Error while processing table!!!\n");
						}
					}
					else
					{			/* col-spanned cell */
						coco = a2l(pp->Value, 1);
						fprintf(myout, "%*s", coco, "-+");
						while (coco > 0)
						{
							if (ptco == NULL)
							{
								ptco = AddSubTagFirst(pt, "XML-TABLE-COLUMN");
							}
							else
							{
								ptco = AddTagAfter(ptco, "XML-TABLE-COLUMN");
							}

							ptco->TextAfter = strdup("\n");

							AddProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
							coco--;
							cocount1++;

							rowspans[cocount1] = rowspans[cocount1 - 1];
						}
						coco = cocount1;
					}

				}
				else
				{				/* from second row */
					if ((pp == NULL) || (a2l(pp->Value, 0) == 1))
					{			/* single cell */
						coco++;
						pp = SearchProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
						if (pp == NULL)
							pp = AddProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
						if ((pp != NULL) && (pp->Value == NULL))
						{
							pp2 = SearchProperty(ptce, "WIDTH");

							if (pp2 != NULL)
							{
								if ((pp2->Value == NULL)
									|| ((strcmp(pp2->Value, "*") != 0)
										&& (strcmp(pp2->Value, "100%") != 0)))
								{
									colwidth =
										ap2f(pp2->Value, -1.0f, tablewidthpix);

									if (colwidth > -1.0f)
									{
										sprintf(&tmpstr[0],
												NumberFormat "cm",
												colwidth * maxTableWidth /
												tablewidthpix);
										pp->Value = strdup(&tmpstr[0]);
										memblocks++;
										fprintf(myout, "x");
									}
									else
										fprintf(myout, "+");
								}
								else
								{
									free(pp2->Value);
									RemoveProperty(ptce, pp2);
									fprintf(myout, "+");
								}
							}
							else
								fprintf(myout, "+");
						}
						else
							fprintf(myout, "+");
						if (ptco != NULL)
							ptco = ptco->Next;
					}
					else
					{			/* col-spanned cell */
						colindex = colspan = a2l(pp->Value, 1);
						fprintf(myout, "%*s", colspan - 1, "-");
						colzaehl = 0;
						pp = SearchProperty(ptce, "WIDTH");
						if ((pp != NULL) && (pp->Value != NULL))
						{
							colwidth = ap2f(pp->Value, 0.0f, tablewidthpix);
							if (colwidth > 0.0f)
								colwidth =
									colwidth * maxTableWidth / tablewidthpix;
						}
						pp2 = NULL;
						while (colspan > 0)
						{
							if (ptco != NULL)
							{
								pp = SearchProperty(ptco,
													"XML-TABLE-COLUMN-WIDTH");
								if (pp == NULL)
									pp = AddProperty(ptco,
													 "XML-TABLE-COLUMN-WIDTH");
								if ((pp != NULL) && (pp->Value != NULL))
								{
									colzaehl++;
									colwidth -= a2f(pp->Value, 0.0f);
								}
								else
								{
									if (pp != NULL)
										pp2 = pp;
								}
								ptco = ptco->Next;
							}
							coco++;
							if (colspan > 1)
								rowspans[coco] = rowspans[coco - 1];
							colspan--;
						}
						if ((colzaehl == colindex - 1)	/* only one column left */
							&& (pp2 != NULL) && (colwidth > 0.0f))
						{
							sprintf(tmpstr, NumberFormat "cm", colwidth);
							pp2->Value = strdup(tmpstr);
							fprintf(myout, "X");
						}
						else
							fprintf(myout, "+");
					}
				}

				if (ptce != NULL)
				{
					ptce = ptce->Next;
				}
			}

			while (rowspans[coco] > 0)
			{
				coco++;
				if (ConvertRowSpans == true)
					AddSubTagLast(ptro, "XML-EMPTY-CELL");
				fprintf(myout, "!");
			}

			fprintf(myout, "\n ");

			colzaehl = cocount1;
			while (colzaehl > 0)
			{
				colzaehl--;
				if (rowspans[colzaehl] > 0)
					rowspans[colzaehl]--;
			}

			if (coco != cocount1)
			{
				fprintf(myout,
						"wrong column count (first row: %i - this row: %i!!!\n ",
						cocount1, coco);
				printTagFilePos(myout, ptro);
				while (coco < cocount1)
				{
					AddSubTagLast(ptro, "XML-EMPTY-CELL");
					coco++;
				}
			}

			ptco = pt->SubTags;

			if (ptro != NULL)
			{
				ptro = ptro->Next;
			}
		}
		fprintf(myout, "table columns retrieved\n");
	}

	fprintf(myout, " recalculating table column width...\n");
	fprintf(myout, "  cutting columns:\n");
	flag = 0;

	do
	{
		ptco = pt->SubTags;
		colwidth = maxTableWidth;
		coco = cocount1;
		colindex = 0;

		Aenderung = false;
		pp2 = NULL;
		colzaehl = 1;
		while ((ptco != NULL)
			   && (strcmp(ptco->Type->Name, "XML-TABLE-COLUMN") == 0))
		{
			pp = SearchProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
			if ((pp != NULL) && (pp->Value != NULL))
			{
				if (a2f(pp->Value, 0) < StdMinColWidth)
				{
					free(pp->Value);
					Aenderung = true;

					sprintf(&tmpstr[0], NumberFormat "cm", StdMinColWidth);
					pp->Value = strdup(&tmpstr[0]);
				}

				colwidth -= a2f(pp->Value, 0);
				coco--;
				if ((pp2 == NULL) || (a2f(pp->Value, 0) > a2f(pp2->Value, 0)))
				{
					colindex = colzaehl;
					pp2 = pp;
				}
			}
			else
			{
				if (pp == NULL)
					AddProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
				if (pp2 == NULL)
					pp2 = pp;
			}
			colzaehl++;
			ptco = ptco->Next;
		}

		if (colwidth < coco * StdMinColWidth)
		{
			ptco = pt->SubTags;
			colzaehl = 1;
			while ((ptco != NULL)
				   && (strcmp(ptco->Type->Name, "XML-TABLE-COLUMN") == 0))
			{
				pp = SearchProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
				if (pp != NULL)
				{
					if (pp->Value != NULL)
					{
						sprintf(&tmpstr[0], NumberFormat "cm",
								(a2f(pp->Value, 0) *
								 ((maxTableWidth - colwidth) -
								  (coco * StdMinColWidth -
								   colwidth)) / (maxTableWidth - colwidth)));
						if (a2f(&tmpstr[0], 0) >= StdMinColWidth)
						{
							flag = 1;
							if (strcmp(pp->Value, &tmpstr[0]) != 0)
							{
								fprintf(myout, "   %i (%s -> %s)\n",
										colzaehl, pp->Value, &tmpstr[0]);
								Aenderung = true;
								free(pp->Value);
								pp->Value = strdup(&tmpstr[0]);
							}
						}
					}
				}
				else
				{
					AddProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
				}
				colzaehl++;
				ptco = ptco->Next;
			}

			if (Aenderung == false)
			{
				sprintf(&tmpstr[0], NumberFormat "cm",
						a2f(pp2->Value, 0) - StdMinColWidth);
				if (a2f(&tmpstr[0], 0) >= StdMinColWidth)
				{
					flag = 1;
					fprintf(myout, "   %i! (%s -> %s)\n", colindex,
							pp2->Value, &tmpstr[0]);
					free(pp2->Value);
					pp2->Value = strdup(&tmpstr[0]);
					Aenderung = true;
				}
			}
		}
	}
	while ((Aenderung == true) || (colwidth < coco * StdMinColWidth));

	if (!flag)
		fprintf(myout, "   none\n");

	fprintf(myout, "  adding values for columns:\n");

	flag = 0;
	colzaehl = 1;
	ptco = pt->SubTags;
	while ((ptco != NULL)
		   && (strcmp(ptco->Type->Name, "XML-TABLE-COLUMN") == 0))
	{
		pp = SearchProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
		if (pp != NULL)
		{
			if (pp->Value == NULL)
			{
				sprintf(&tmpstr[0], NumberFormat "cm", colwidth / coco);
				pp->Value = strdup(&tmpstr[0]);
				memblocks++;
				fprintf(myout, "   %i (%s)", colzaehl, pp->Value);
				flag = 1;
			}
		}
		colzaehl++;
		ptco = ptco->Next;
	}

	if (!flag)
		fprintf(myout, "   none\n");
	fprintf(myout, " done\n");

	ptro = ptbo->SubTags;

	fprintf(myout, " processing table cells...\n");

	while (ptro != NULL)
	{
		ptco = pt->SubTags;
		ptce = ptro->SubTags;
		coco = 0;
		while (ptce != NULL)
		{
			while (rowspans[coco] > 0)
			{
				coco++;
				if ((ptco != NULL) && (ptco->Next != NULL))
				{
					ptco = ptco->Next;
				}
				else
					fprintf(myout,
							"internal error while table processing!!!\n ");
			}

			pp = SearchProperty(ptce, "ROWSPAN");

			if (pp != NULL)
			{
				rowspans[coco] = a2l(pp->Value, 0);
			}

			pp = SearchProperty(ptce, "COLSPAN");

			if ((pp != NULL) && (pp->Value != NULL))
			{
				colspan = a2l(pp->Value, 1);
			}
			else
				colspan = 1;

			colwidth = 0.0f;
			while (colspan > 0)
			{
				if (ptco != NULL)
				{
					pp = SearchProperty(ptco, "XML-TABLE-COLUMN-WIDTH");
					if ((pp != NULL) && (pp->Value != NULL))
					{
						colwidth += a2f(pp->Value, 0.0f);
					}
					ptco = ptco->Next;
				}
				colspan--;
				coco++;
				if (colspan > 1)
					rowspans[coco] = rowspans[coco - 1];
			}

			if (ppb != NULL)
				colwidth -= (a2f(ppb->Value, 0.0f) * 2.54f / 72);

			sprintf(&tmpstr[0], NumberFormat "cm", colwidth);

			WarnProperties = false;
			AddPropertyValue(ptce,
							 "XML-CONFIG-MAX-CONTENT-WIDTH",
							 strdup(&tmpstr[0]));
			WarnProperties = true;

			ptce = ptce->Next;
		}

		colzaehl = cocount1;
		while (colzaehl > 0)
		{
			colzaehl--;
			if (rowspans[colzaehl] > 0)
				rowspans[colzaehl]--;
		}

		ptro = ptro->Next;
	}

	fprintf(myout, "done step 1 of table processing\n");
	return true;
}

char ProcessTagTable(tPTag pTag)
{
	tPTag pt = pTag, ptco = NULL, ptbo = NULL, ptro, ptce = NULL, ptfo;
	tPProperty pp, ppb;
	int cocount1 = 0, coco, colspan, colzaehl, colindex;
	int tablewidthpix = StdDocWidthPixel;
	float colwidth = 0.0f;
	int rowspans[100] = { 0 };

	fprintf(myout, "starting table processing step 2 of 2 - depth %i\n",
			TableDepth);
	TableDepth--;

	ppb = SearchProperty(pt, "BORDER");

	ptco = pt->SubTags;
	if ((ptco != NULL) && (ptco->Type == SearchTagType(pt, "XML-TABLE-COLUMN")))
	{

		cocount1 = 1;

		while ((ptco != NULL)
			   && (ptco->Next->Type == SearchTagType(pt, "XML-TABLE-COLUMN")))
		{
			cocount1++;
			ptco = ptco->Next;
		}

		ptbo = ptco->Next;
		ptro = ptbo->SubTags;
		ptco = pt->SubTags;

		fprintf(myout, " processing table cells...\n  ");

		memset(rowspans, sizeof(rowspans), 0);

		while (ptro != NULL)
		{
			ptce = ptro->SubTags;
			coco = 0;

			while (ptce != NULL)
			{
				fprintf(myout, "+");
				if ((strcmp(ptce->Type->Name, "XML-EMPTY-CELL") != 0)
					&& (ppb != NULL) && (strcmp(ppb->Value, "0pt") != 0))
				{
					AddPropertySeparator(ptce);
					if (!ConvertTableBorders)
					{
						AddPropertyValue(ptce, "XML-BORDER-WIDTH",
										 strdup(ppb->Value));
						AddPropertyValue(ptce, "XML-BORDER-COLOR",
										 strdup("black"));
						AddPropertyValue(ptce, "XML-BORDER-STYLE",
										 strdup("solid"));
						AddPropertySeparator(ptce);
					}
					else
					{
						AddPropertyValue(ptce, "XML-BORDER-LEFT-WIDTH",
										 strdup(ppb->Value));
						AddPropertyValue(ptce, "XML-BORDER-LEFT-COLOR",
										 strdup("black"));
						AddPropertyValue(ptce, "XML-BORDER-LEFT-STYLE",
										 strdup("solid"));
						AddPropertySeparator(ptce);

						AddPropertyValue(ptce, "XML-BORDER-TOP-WIDTH",
										 strdup(ppb->Value));
						AddPropertyValue(ptce, "XML-BORDER-TOP-COLOR",
										 strdup("black"));
						AddPropertyValue(ptce, "XML-BORDER-TOP-STYLE",
										 strdup("solid"));
						AddPropertySeparator(ptce);
						if (ptce->Next == NULL)
						{
							AddPropertyValue(ptce,
											 "XML-BORDER-RIGHT-WIDTH",
											 strdup(ppb->Value));
							AddPropertyValue(ptce,
											 "XML-BORDER-RIGHT-COLOR",
											 strdup("black"));
							AddPropertyValue(ptce,
											 "XML-BORDER-RIGHT-STYLE",
											 strdup("solid"));
							AddPropertySeparator(ptce);
						}
						if (ptbo->SubTags->Next == NULL)
						{
							AddPropertyValue(ptce,
											 "XML-BORDER-BOTTOM-WIDTH",
											 strdup(ppb->Value));
							AddPropertyValue(ptce,
											 "XML-BORDER-BOTTOM-COLOR",
											 strdup("black"));
							AddPropertyValue(ptce,
											 "XML-BORDER-BOTTOM-STYLE",
											 strdup("solid"));
							AddPropertySeparator(ptce);
						}
					}
				}

				if (SetupParagraph(0, ptce) == true)
				{				/* thats a hack... I know */
					pp = SearchProperty(ptce, "HEIGHT");
					if (pp != NULL)
						pp->Type =
							SearchPropertyType("XML-NO-HEIGHT", ptce->Type);
				}

				pp = SearchProperty(ptce, "ALIGN");

				if (pp != NULL)
				{
					/* Do not print Warnings for Properties which could not added */
					WarnProperties = false;
					AddTreePropertyValue(ptce->SubTags, "ALIGN", pp->Value,
										 true, true);
					WarnProperties = true;
				}

				while (rowspans[coco] > 0)
				{
					coco++;
					fprintf(myout, "!");
				}

				pp = SearchProperty(ptce, "ROWSPAN");

				if (pp != NULL)
				{
					rowspans[coco] = a2l(pp->Value, 0);
					if (ConvertRowSpans == true)
						pp->Type =
							SearchPropertyType("REMOVED-ROWSPAN", ptce->Type);
				}

				pp = SearchProperty(ptce, "COLSPAN");

				if (pp != NULL)	/* Property COLSPAN */
				{
					colindex = colspan = a2l(pp->Value, 1);
					while (colspan > 0)
					{
						coco++;
						if (colspan > 1)
							rowspans[coco] = rowspans[coco - 1];
						colspan--;
						fprintf(myout, "-");
					}
				}
				else
				{
					if (ptco != NULL)
					{
						ptco = ptco->Next;
					}
					coco++;
				}

				if (ptce != NULL)
				{
					ptce = ptce->Next;
				}
			}

			pp = SearchProperty(ptro, "ALIGN");

			if (pp != NULL)
			{
				/* Do not print Warnings for Properties which could not added */
				WarnProperties = false;
				AddTreePropertyValue(ptro->SubTags, "ALIGN", pp->Value,
									 true, true);
				WarnProperties = true;
			}

			while (rowspans[coco] > 0)
			{
				coco++;
				fprintf(myout, "!");
			}

			fprintf(myout, "+\n  ");

			colzaehl = cocount1;
			while (colzaehl > 0)
			{
				colzaehl--;
				if (rowspans[colzaehl] > 0)
					rowspans[colzaehl]--;
			}

			if (coco != cocount1)
			{
				fprintf(myout,
						"wrong column count (first row: %i - last row: %i!!!\n",
						cocount1, coco);
			}

			ptco = pt->SubTags;

			if (ptro != NULL)
			{
				ptro = ptro->Next;
			}
		}

		fprintf(myout, "done\n");

		if ((ConvertTableBorders)
			&& (ppb != NULL)
			&& (strcmp(ppb->Value, "0pt") != 0)
			&& (ptbo->SubTags->Next != NULL))
		{
			fprintf(myout, " adding table footer\n");
			ptco = pt->SubTags;

			ptfo = AddTagAfter(GetPrevTag(ptbo), "XML-TABLE-FOOTER");
			if (ptfo != NULL)
			{
				ptro = AddSubTagLast(ptfo, "TR");

				if (ptro != NULL)
				{
					while (strcmp(ptco->Type->MapTo, "fo:table-column") == 0)
					{
						ptce = AddSubTagLast(ptro, "TD");
						if (ptce != NULL)
						{
							ptce->TextAfter = strdup("\r\n");
							AddPropertySeparator(ptce);
							if (ptce == ptro->SubTags)
							{
								AddPropertyValue(ptce,
												 "XML-BORDER-LEFT-WIDTH",
												 strdup(ppb->Value));
								AddPropertyValue(ptce,
												 "XML-BORDER-LEFT-COLOR",
												 strdup("black"));
								AddPropertyValue(ptce,
												 "XML-BORDER-LEFT-STYLE",
												 strdup("solid"));
								AddPropertySeparator(ptce);
							}
							AddPropertyValue(ptce,
											 "XML-BORDER-BOTTOM-WIDTH",
											 strdup(ppb->Value));
							AddPropertyValue(ptce,
											 "XML-BORDER-BOTTOM-COLOR",
											 strdup("black"));
							AddPropertyValue(ptce,
											 "XML-BORDER-BOTTOM-STYLE",
											 strdup("solid"));
							AddPropertySeparator(ptce);
							if (strcmp
								(ptco->Next->Type->MapTo,
								 "fo:table-column") != 0)
							{
								AddPropertyValue(ptce,
												 "XML-BORDER-RIGHT-WIDTH",
												 strdup(ppb->Value));
								AddPropertyValue(ptce,
												 "XML-BORDER-RIGHT-COLOR",
												 strdup("black"));
								AddPropertyValue(ptce,
												 "XML-BORDER-RIGHT-STYLE",
												 strdup("solid"));
								AddPropertySeparator(ptce);
							}
						}
						ptco = ptco->Next;
					}
				}
			}
			fprintf(myout, " done\n");
		}
		fprintf(myout, "done all table processing\n");
	}
	return 1;
}

